@title run-SonarQube-all.bat
cls
@echo.
@echo -------------------------------------------------------------------------
@echo run-SonarQube-all.bat
@echo -------------------------------------------------------------------------
@echo.

pushd .
set _SONAR_START_BAT=\Tools\SonarQube\bin\windows-x86-64\StartSonar.bat
set _IGNORED_DIRS=MvnAppSrvFailsaveIntTest MvnAppSrvIntTest MvnMultiProj1 MvnMultiProj2 MvnMultiProj3 MvnSign
@if not exist "%_SONAR_START_BAT%" goto _Fehler

set JAVA_HOME=C:\Program Files\Java\jdk1.8
PATH=%JAVA_HOME%\bin;%PATH%
echo JAVA_HOME=%JAVA_HOME%
java -version
javac -version

netstat -an | find "0.0.0.0:9000"
@if not errorlevel 1 goto _Sonar_Server_fertig
start "SonarQube" "%_SONAR_START_BAT%"
:_Warte_Sonar_Server
@echo Warten auf den Sonar-Server ...
@ping -n 5 127.0.0.1>nul
@netstat -an | find "0.0.0.0:9000"
@if errorlevel 1 goto _Warte_Sonar_Server
:_Sonar_Server_fertig
start http://localhost:9000

cd ..
@echo off

FOR /F %%i in ('dir /B /A:D') DO (
  echo.
  call :checkignored %%i
  if not errorlevel 1 (
    if exist %%i\pom.xml (
      echo.
      echo -------------------------------------------------------------------------
      echo Projektverzeichnis: %%i
      echo -------------------------------------------------------------------------
      echo on
      cd %%i
      echo.
      echo ---- SonarQube fuer %%i:
      echo.
      call mvn clean org.jacoco:jacoco-maven-plugin:prepare-agent install -Dmaven.test.failure.ignore=true
      call mvn sonar:sonar
      if errorlevel 1 goto _Fehler
      @echo on
      echo.
      cd ..
      echo off
    )
  )
)

@echo 
start http://localhost:9000

if exist SonarQubeRci\pom.xml (
  cd SonarQubeRci
  if not exist target\SonarQubeRci-jar-with-dependencies.jar (
    call mvn clean package
    @echo on
  )
  java -jar target\SonarQubeRci-jar-with-dependencies.jar http://localhost:9000 10/5/3/1/0
  start SonarQube-RCI-sortRci.html
  cd ..
)

@goto _fertig

:checkignored
FOR /D %%j in (%_IGNORED_DIRS%) DO IF "%1"=="%%j" EXIT /B 1
exit /B 0

:_Fehler
@echo.
@echo -------------------------------------------------------------------------
@echo !!! Fehler !!!
@echo -------------------------------------------------------------------------
@echo 
pause

:_fertig
@echo on
@echo.
popd
@echo.
