#!/bin/bash

echo
echo -------------------------------------------------------------------------
echo run-SonarQube-all.sh
echo -------------------------------------------------------------------------
echo

_IGNORED_DIRS=" MvnAppSrvFailsaveIntTest MvnAppSrvIntTest MvnMultiProj1 MvnMultiProj2 MvnMultiProj3 MvnSign SonarUndSiteReport "

if ! netstat -ant | grep -q ':9000'
then
   /opt/sonarqube/bin/linux-x86-64/sonar.sh start &
fi

while ! netstat -ant | grep -q ':9000'
do echo Warten auf den SonarQube-Server ... ; sleep 5
done

echo
cd ..
echo "Aktuelles Verzeichnis: "$(pwd)
echo
ls -l
echo

for verzeichnis in *
do
   echo -e "\n------------------------------------------------------"
   if [[ $_IGNORED_DIRS == *${verzeichnis}* ]]
   then
      echo "---- "${verzeichnis}" ist zu ignorieren ----"
   elif [ ! -d "${verzeichnis}" ]
   then
      echo "---- "${verzeichnis}" ist kein Verzeichnis ----"
   elif [ ! -f "${verzeichnis}/pom.xml" ]
   then
      echo "---- "${verzeichnis}" enthaelt keine pom.xml ----"
   else
      echo "---- "${verzeichnis}":"
      cd "${verzeichnis}"

      mvn clean org.jacoco:jacoco-maven-plugin:prepare-agent install -Dmaven.test.failure.ignore=true
      mvn sonar:sonar || exit 1

      cd ..
   fi
done

echo -e "\n------------------------------------------------------\n"
( speaker-test -t sine -f 1000 > /dev/null )& pid=$! ; sleep 0.1s ; kill -9 $pid
echo -e "\n++++ OK ++++\n"
